#NoTrayIcon
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=gfx\prog.ico
#AutoIt3Wrapper_outfile=Musik-Quiz v4.exe
#AutoIt3Wrapper_UseUpx=n
#AutoIt3Wrapper_UseX64=n
#AutoIt3Wrapper_Res_Description=Musik-Quiz v4
#AutoIt3Wrapper_Res_Fileversion=4.3.0.0
#AutoIt3Wrapper_Res_LegalCopyright=Oscar (www.autoit.de)
#AutoIt3Wrapper_Res_Language=1031
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#include <Array.au3>
#include <ButtonConstants.au3>
#include <ComboConstants.au3>
#include <Crypt.au3>
#include <EditConstants.au3>
#include <GuiComboBox.au3>
#include <GUIConstantsEx.au3>
#include <GuiListView.au3>
#include <GuiStatusBar.au3>
#include <ListViewConstants.au3>
#include <Misc.au3>
#include <ProgressConstants.au3>
#include <SliderConstants.au3>
#include <Sound.au3>
#include <StaticConstants.au3>
#include <String.au3>
#include <WinAPI.au3>
#include <WindowsConstants.au3>
#include "bass\BassConstants.au3"
#include "bass\Bass.au3"

Opt('GUIOnEventMode', 1)
Opt('GUICloseOnESC', 0)

Global $sTitle = 'Musik-Quiz'
If Not @Compiled And @AutoItVersion < '3.3.6.0' Then Exit MsgBox(16, $sTitle, 'Dieses Skript bentigt min. AutoIt-Version 3.3.6.0')
_Singleton($sTitle)
Global $sVersion = '4.3.0.0'
Global $sVerDate = '16.05.2010'
Global $sAvatarPath = @ScriptDir & '\avatare\'
Global $sGfxPath = @ScriptDir & '\gfx\'
Global $sAppPath = @AppDataDir & '\Musik-Quiz v4\'
If Not FileExists($sAppPath) Then DirCreate($sAppPath)
Global $sIniFile = $sAppPath & 'Musik-Quiz.ini'
Global $sDBFile = $sAppPath & 'Musik-Quiz.db'
Global $sHiScoreFile = $sAppPath & 'HiScore.db'
Global $sHelpFile = @ScriptDir & '\Musik-Quiz v4.chm'
Global $aUserHiScore[4][7], $aHiScoreList[100][7], $sPassword, $fNewGame = False
_Init()

Global $sMP3WorkDir = IniRead($sIniFile, 'Config', 'MP3WorkDir', @WorkingDir)

Global $ahAvatar[4][8], $ahChoice[4][2], $aMP3Pool[1] = [0], $aMP3PoolBack = $aMP3Pool
Global $fMP3Select = False, $hSoundOpen = 0, $iTimeScore, $iCorrect = -1, $iFinish = 0
Global $JOYINFOEX_struct = 'dword[13]'

Global $iOrigWidth = @DesktopWidth
Global $iOrigHeight = @DesktopHeight
Global $fDisplayRes = Execute(IniRead($sIniFile, 'Config', '1024x768', False))

Global $aNumberJoy = _NumberJoy(), $sComboData = 'Tastatur', $aComboData
If $aNumberJoy[0] > 0 Then
	For $j = 1 To $aNumberJoy[0]
		$sComboData &= '|' & 'Gamepad Nr. ' & $aNumberJoy[$j] + 1
	Next
EndIf
$aComboData = StringSplit($sComboData, '|', 2)

$hGui = GUICreate($sTitle & ' v4    ' & Chr(169) & ' by Oscar (www.autoit.de)', 1000, 720, -1, 10, Default, $WS_EX_TOPMOST)
GUISetOnEvent($GUI_EVENT_CLOSE, '_End')
GUISetBkColor(0xFFBB88)
GUISetIcon($sGfxPath & 'prog.ico')

$hMenuProg = GUICtrlCreateMenu('Programm')
GUICtrlCreateMenuItem('Neues Spiel', $hMenuProg)
GUICtrlSetOnEvent(-1, '_MenuNewGame')
GUICtrlCreateMenuItem('', $hMenuProg)
GUICtrlCreateMenuItem('Programm beenden', $hMenuProg)
GUICtrlSetOnEvent(-1, '_End')
$hMenuConfig = GUICtrlCreateMenu('Einstellungen')
$hMenuConfigDisplay = GUICtrlCreateMenuItem('Monitorauflsung umschalten (1024x768)', $hMenuConfig)
GUICtrlSetOnEvent(-1, '_ChangeDisplay')
$hMenuConfigSelect = GUICtrlCreateMenuItem('MP3-Ordner auswhlen', $hMenuConfig)
GUICtrlSetOnEvent(-1, '_SelectMP3Folder')
$hMenuHelp = GUICtrlCreateMenu('Hilfe')
GUICtrlCreateMenuItem('Hilfedatei ffnen...', $hMenuHelp)
GUICtrlSetOnEvent(-1, '_Help')
GUICtrlCreateMenuItem('Tastatur-Belegung', $hMenuHelp)
GUICtrlSetOnEvent(-1, '_KeyboardInfo')
GUICtrlCreateMenuItem('Danksagungen', $hMenuHelp)
GUICtrlSetOnEvent(-1, '_Thanks')
GUICtrlCreateMenuItem('Programm-Informationen', $hMenuHelp)
GUICtrlSetOnEvent(-1, '_ProgInfo')

$hDummy = GUICtrlCreateInput('', -40, -40, 20, 20)

$hBkPic = GUICtrlCreatePic($sGfxPath & 'background.jpg', 0, 0, 1000, 480)
GUICtrlSetState(-1, $GUI_DISABLE)
DllCall('uxtheme.dll', 'none', 'SetThemeAppProperties', 'int', 0)
$hSpeaker1 = GUICtrlCreateIcon($sGfxPath & 'speaker.ico', -1, 3, 25, 95, 123)
GUICtrlSetState(-1, $GUI_DISABLE)
GUICtrlSetState(-1, $GUI_HIDE)
$hLevel1 = GUICtrlCreateProgress(104, 26, 20, 120, BitOR($PBS_SMOOTH, $PBS_VERTICAL))
GUICtrlSetColor(-1, 0x44DD44)
GUICtrlSetState(-1, $GUI_HIDE)
$hLine1 = GUICtrlCreateLabel('', 0, 145, 130, 8)
GUICtrlSetBkColor(-1, 0x444444)
GUICtrlSetState(-1, $GUI_HIDE)
$hSpeaker2 = GUICtrlCreateIcon($sGfxPath & 'speaker.ico', -1, 902, 25, 95, 123)
GUICtrlSetState(-1, $GUI_DISABLE)
GUICtrlSetState(-1, $GUI_HIDE)
$hLevel2 = GUICtrlCreateProgress(876, 26, 20, 120, BitOR($PBS_SMOOTH, $PBS_VERTICAL))
GUICtrlSetColor(-1, 0x44DD44)
GUICtrlSetState(-1, $GUI_HIDE)
$hLine2 = GUICtrlCreateLabel('', 870, 145, 130, 8)
GUICtrlSetBkColor(-1, 0x444444)
GUICtrlSetState(-1, $GUI_HIDE)
DllCall('uxtheme.dll', 'none', 'SetThemeAppProperties', 'int', 7)

$hFolder = GUICtrlCreateButton('', 300, 228, 128, 128, $BS_ICON)
GUICtrlSetImage(-1, $sGfxPath & 'folder.ico')
GUICtrlSetOnEvent(-1, '_SelectMP3Folder')
GUICtrlSetTip(-1, 'MP3-Ordner auswhlen')
$hFinish = GUICtrlCreateButton('', 435, 228, 128, 128, $BS_ICON)
GUICtrlSetImage(-1, $sGfxPath & 'finish.ico')
GUICtrlSetOnEvent(-1, '_SelectFinish')
GUICtrlSetTip(-1, 'Ziel auswhlen')
$hStart = GUICtrlCreateButton('', 570, 228, 128, 128, $BS_ICON)
GUICtrlSetImage(-1, $sGfxPath & 'start0.ico')
GUICtrlSetState(-1, $GUI_DISABLE)
GUICtrlSetOnEvent(-1, '_StartGame')
GUICtrlSetTip(-1, 'Spiel starten')

$hNote1 = GUICtrlCreateIcon($sGfxPath & 'noteL.ico', -1, 0, 435, 128, 128)
GUICtrlSetState(-1, $GUI_DISABLE)
GUICtrlSetState(-1, $GUI_HIDE)
$hNote2 = GUICtrlCreateIcon($sGfxPath & 'noteR.ico', -1, 872, 435, 128, 128)
GUICtrlSetState(-1, $GUI_DISABLE)
GUICtrlSetState(-1, $GUI_HIDE)

For $i = 0 To 3
	$ahChoice[$i][0] = GUICtrlCreateLabel('Taste ' & $i + 1, 140 + Mod($i, 2) * 370, 25 + Int($i / 2) * 120, 350, 25, $SS_CENTER, $WS_EX_STATICEDGE)
	GUICtrlSetFont(-1, 14, 400, 0, 'Tahoma')
	GUICtrlSetColor(-1, 0xFFFF44)
	GUICtrlSetBkColor(-1, 0x3333AA)
	GUICtrlSetState(-1, $GUI_HIDE)
	$ahChoice[$i][1] = GUICtrlCreateLabel('', 140 + Mod($i, 2) * 370, 50 + Int($i / 2) * 120, 350, 80, $SS_CENTER, $WS_EX_STATICEDGE)
	GUICtrlSetFont(-1, 18, 400, 0, 'Times New Roman')
	GUICtrlSetBkColor(-1, 0xDDDDFF)
	GUICtrlSetState(-1, $GUI_HIDE)
Next

$hScoreLabel = GUICtrlCreateLabel('Punkte', 5, 270, 95, 20, $SS_CENTER)
GUICtrlSetFont(-1, 12, 400, 0, 'Tahoma')
GUICtrlSetState(-1, $GUI_HIDE)
$hScore = GUICtrlCreateLabel('0', 5, 290, 95, 30, $SS_CENTER, $WS_EX_CLIENTEDGE)
GUICtrlSetFont(-1, 16, 400, 0, 'Verdana')
GUICtrlSetColor(-1, 0xFFFF44)
GUICtrlSetBkColor(-1, 0x3333AA)
GUICtrlSetState(-1, $GUI_HIDE)
DllCall('uxtheme.dll', 'none', 'SetThemeAppProperties', 'int', 0)
$hTimeScore = GUICtrlCreateProgress(105, 290, 790, 30, $PBS_SMOOTH)
GUICtrlSetColor(-1, 0x3333AA)
GUICtrlSetState(-1, $GUI_HIDE)
DllCall('uxtheme.dll', 'none', 'SetThemeAppProperties', 'int', 7)
Global $ahProgrTics[21], $ahProgrLabel[5]
For $i = 0 To 20
	If Mod($i, 5) = 0 Or $i = 0 Then
		$ahProgrLabel[Int($i / 5)] = GUICtrlCreateLabel($i & ' s', 98 + $i * 39.3, 337, 30, 20, $SS_CENTER)
		GUICtrlSetState(-1, $GUI_HIDE)
		GUICtrlSetFont(-1, 12, 400, 0, 'Tahoma')
		$y = 14
	Else
		$y = 6
	EndIf
	$ahProgrTics[$i] = GUICtrlCreateLabel('', 107 + $i * 39.3, 321, 1, $y)
	GUICtrlSetState(-1, $GUI_HIDE)
	GUICtrlSetBkColor(-1, 0x000000)
Next
$hCountLabel = GUICtrlCreateLabel('Quiz Nr.', 900, 270, 95, 20, $SS_CENTER)
GUICtrlSetFont(-1, 12, 400, 0, 'Tahoma')
GUICtrlSetState(-1, $GUI_HIDE)
$hCount = GUICtrlCreateLabel('0', 900, 290, 95, 30, $SS_CENTER, $WS_EX_CLIENTEDGE)
GUICtrlSetFont(-1, 16, 400, 0, 'Verdana')
GUICtrlSetColor(-1, 0xFFFF44)
GUICtrlSetBkColor(-1, 0x3333AA)
GUICtrlSetState(-1, $GUI_HIDE)

For $i = 0 To 3
	GUIStartGroup()
	$ahAvatar[$i][0] = GUICtrlCreateButton('0', 174 + $i * 175, 440, 134, 134, BitOR($BS_ICON, $BS_MULTILINE))
	GUICtrlSetImage(-1, $sAvatarPath & 'fm.ico')
	GUICtrlSetFont(-1, 12, 400, 0, 'Verdana')
	GUICtrlSetOnEvent(-1, '_ActivateUser')
	GUICtrlSetTip(-1, 'Mitspieler de-/aktivieren')
	$ahAvatar[$i][1] = GUICtrlCreateLabel('0', 177 + $i * 175, 410, 130, 25, $SS_RIGHT, $WS_EX_CLIENTEDGE)
	GUICtrlSetFont(-1, 14, 400, 0, 'Verdana')
	GUICtrlSetBkColor(-1, 0xAAFFAA)
	GUICtrlSetState(-1, $GUI_HIDE)
	DllCall('uxtheme.dll', 'none', 'SetThemeAppProperties', 'int', 0)
	$ahAvatar[$i][2] = GUICtrlCreateSlider(308 + $i * 175, 440, 35, 134, BitOR($TBS_VERT, $TBS_LEFT))
	GUICtrlSetBkColor(-1, 0xFFBB88)
	GUICtrlSetLimit(-1, 14, 0)
	GUICtrlSetOnEvent(-1, '_SelectGender')
	GUICtrlSetTip(-1, 'Avatar auswhlen')
	GUICtrlSetState(-1, $GUI_HIDE)
	DllCall('uxtheme.dll', 'none', 'SetThemeAppProperties', 'int', 7)
	$ahAvatar[$i][3] = GUICtrlCreateRadio('Frau', 182 + $i * 175, 578, 45, 20)
	GUICtrlSetState(-1, $GUI_CHECKED)
	GUICtrlSetOnEvent(-1, '_SelectGender')
	GUICtrlSetState(-1, $GUI_HIDE)
	$ahAvatar[$i][4] = GUICtrlCreateRadio('Mann', 247 + $i * 175, 578, 45, 20)
	GUICtrlSetOnEvent(-1, '_SelectGender')
	GUICtrlSetState(-1, $GUI_HIDE)
	$ahAvatar[$i][5] = GUICtrlCreateInput('Spieler ' & $i + 1, 177 + $i * 175, 600, 130, 20, $ES_CENTER)
	GUICtrlSetFont(-1, 10, 400, 0, 'Verdana')
	GUICtrlSetTip(-1, 'Vornamen des Spielers eingeben')
	GUICtrlSetState(-1, $GUI_HIDE)
	$ahAvatar[$i][6] = GUICtrlCreateCombo('', 177 + $i * 175, 625, 130, 20, $CBS_DROPDOWNLIST)
	GUICtrlSetData(-1, $sComboData, $aComboData[0])
	GUICtrlSetTip(-1, 'Eingabegert auswhlen')
	GUICtrlSetState(-1, $GUI_HIDE)
	$ahAvatar[$i][7] = GUICtrlCreateLabel('Eingabe-Test', 177 + $i * 175, 650, 130, 24, $SS_CENTER, $WS_EX_CLIENTEDGE)
	GUICtrlSetFont(-1, 10, 400, 0, 'Verdana')
	GUICtrlSetBkColor(-1, 0x55FF55)
	GUICtrlSetTip(-1, 'Eingabegert testen (Tastatur-Belegung siehe Hilfe)')
	GUICtrlSetState(-1, $GUI_HIDE)
Next
$hHiScoreTable = GUICtrlCreateListView('Platz|Name|Anzahl der Lieder|Richtige Antworten|Falsche Antworten|Punkte|Durchschnitt', 100, 0, 800, 280, Default, $LVS_EX_GRIDLINES)
GUICtrlSetState(-1, $GUI_HIDE)
_GUICtrlListView_SetColumn($hHiScoreTable, 0, 'Platz', 40, 1)
_GUICtrlListView_SetColumn($hHiScoreTable, 1, 'Name', 180, 0)
_GUICtrlListView_SetColumn($hHiScoreTable, 2, 'Anzahl der Lieder', 110, 1)
_GUICtrlListView_SetColumn($hHiScoreTable, 3, 'Richtige Antworten', 120, 1)
_GUICtrlListView_SetColumn($hHiScoreTable, 4, 'Falsche Antworten', 120, 1)
_GUICtrlListView_SetColumn($hHiScoreTable, 5, 'Punkte', 80, 1)
_GUICtrlListView_SetColumn($hHiScoreTable, 6, 'Durchschnitt', 100, 1)

Global $aMainStatusParts[2] = [700, -1]
$hMainStatus = _GUICtrlStatusBar_Create($hGui, $aMainStatusParts)
$hInfoIcon = _WinAPI_LoadShell32Icon(221)
$hAudioIcon = _WinAPI_LoadShell32Icon(116)
$hNoIcon = _WinAPI_LoadShell32Icon(219)
_GUICtrlStatusBar_SetIcon($hMainStatus, 0, $hInfoIcon)
_GUICtrlStatusBar_SetIcon($hMainStatus, 1, $hNoIcon)
_GUICtrlStatusBar_SetText($hMainStatus, ' Einstellungen fr das Spiel vornehmen.')
_GUICtrlStatusBar_SetText($hMainStatus, ' Keine MP3-Dateien ausgewhlt!', 1)

$hSelectFolder = GUICreate($sTitle & '  -  MP3-Ordner', 480, 320, -1, -1, BitOR($WS_SYSMENU, $WS_CAPTION), $WS_EX_TOPMOST, $hGui)
GUISetIcon($sGfxPath & 'folder.ico')
$hListView = GUICtrlCreateListView('MP3-Ordner (inkl. Unterordner)|Anzahl', 10, 10, 460, 240, $LVS_SHOWSELALWAYS)
GUICtrlSendMsg($hListView, $LVM_SETCOLUMNWIDTH, 0, 370)
$hWndLW = GUICtrlGetHandle($hListView)
$hClear = GUICtrlCreateButton('Neue Liste', 10, 260, 90, 30)
$hAdd = GUICtrlCreateButton('Ordner hinzufgen', 110, 260, 110, 30)
$hDel = GUICtrlCreateButton('markierte Ordner entfernen', 230, 260, 150, 30)
$hOk = GUICtrlCreateButton('Ok', 400, 260, 70, 30)
$hStatus = _GUICtrlStatusBar_Create($hSelectFolder)
_GUICtrlStatusBar_SetText($hStatus, ' Bereit.')
_GUICtrlStatusBar_SetIcon($hStatus, 0, $hInfoIcon)

If $fDisplayRes Then
	$fDisplayRes = False
	_ChangeDisplay()
EndIf
GUISetState(@SW_SHOW, $hGui)
GUIRegisterMsg($WM_VSCROLL, '_WM_VSCROLL')

_LoadDB($sDBFile, $hListView)
_ReadMP3Pool()
$vDLL = DllOpen('user32.dll')
AdlibRegister('_TestInput', 25)

Global $iLevel, $iLeft, $iRight, $iHigh = 0
While Sleep(20)
	If $hSoundOpen Then
		$iLevel = _BASS_ChannelGetLevel($hSoundOpen)
		$iLeft = _HiWord($iLevel)
		$iRight = _LoWord($iLevel)
		If $iLeft > $iHigh Then $iHigh = $iLeft
		If $iRight > $iHigh Then $iHigh = $iRight
		GUICtrlSetData($hLevel1, Int($iLeft / $iHigh * 100))
		GUICtrlSetData($hLevel2, Int($iRight / $iHigh * 100))
	EndIf
	If $fNewGame Then
		GUICtrlSetData($hLevel1, 0)
		GUICtrlSetData($hLevel2, 0)
		$iHigh = 0
		$fNewGame = False
		AdlibUnRegister('_GetUserInput')
		AdlibUnRegister('_RefreshScore')
		If $hSoundOpen Then
			_BASS_ChannelStop($hSoundOpen)
			$hSoundOpen = 0
		EndIf
		_RefreshHiScoreTable(True)
		_SaveHiScoreList()
		_ShowChoice($GUI_HIDE)
		_NewGame()
	EndIf
WEnd

Func _End()
	If MsgBox(4 + 32 + 256 + 262144, 'Spiel beenden?', 'Das Spiel wirklich beenden?', 0, $hGui) = 7 Then Return
	AdlibUnRegister('_TestInput')
	AdlibUnRegister('_GetUserInput')
	AdlibUnRegister('_RefreshScore')
	_BASS_Free()
	_WinAPI_DestroyIcon($hInfoIcon)
	_WinAPI_DestroyIcon($hAudioIcon)
	_WinAPI_DestroyIcon($hNoIcon)
	GUIDelete($hGui)
	DllClose($vDLL)
	If $fDisplayRes Then _ChangeScreenResEx(1, $iOrigWidth, $iOrigHeight)
	Sleep(1000)
	Exit
EndFunc   ;==>_End

Func _Help()
	Local $rc
	ShellExecute($sHelpFile)
	$rc = WinWait('HTML', '', 3)
	WinSetOnTop('HTML', '', 1)
	If $rc = 0 Then Return MsgBox(0 + 262144, $sTitle, 'Die Hilfedatei konnte nicht geffnet werden!', 0, $hGui)
	WinMove('HTML', '', Int(@DesktopWidth / 2) - 490, 30, 980, 600)
	ControlMove('HTML', '', '[CLASS:HH Child; INSTANCE:2]', 0, 40, 260)
	ControlMove('HTML', '', '[CLASS:HH Child; INSTANCE:1]', 264, 40)
	ControlTreeView('HTML', '', '[CLASS:SysTreeView32; INSTANCE:1]', 'Expand', '#0')
EndFunc   ;==>_Help

Func _Init()
	If Not FileExists('bass\bass.dll') Then Exit MsgBox(16, $sTitle, 'Fehler!' & @CRLF & 'Die Datei "bass.dll" konnte nicht gefunden werden!')
	_BASS_STARTUP('bass\bass.dll')
	_BASS_Init(0, -1, 44100, 0, '')
	If @error Then Exit MsgBox(16, $sTitle, 'Fehler!' & @CRLF & 'Die Soundkarte konnte nicht initialisiert werden!')
	$sPassword = '7u9yf4xIidd50nlRXJDt226Pmq09h4EiX962NyJ469yr9FWmLAY08y336Duu330'
	_LoadHiScoreList()
	If @error Then
		For $i = 0 To 99
			$aHiScoreList[$i][0] = $i + 1
			$aHiScoreList[$i][1] = ''
			$aHiScoreList[$i][2] = 0
			$aHiScoreList[$i][3] = 0
			$aHiScoreList[$i][4] = 0
			$aHiScoreList[$i][5] = 0
			$aHiScoreList[$i][6] = 0
		Next
	EndIf
EndFunc   ;==>_Init

Func _SelectFinish()
	Local $hFinishGui, $aWinPos, $aContrPos, $iX, $iY, $hF1, $hF2, $hF3, $hF4
	$aWinPos = WinGetPos($hGui)
	$aContrPos = ControlGetPos($hGui, '', $hFinish)
	$iX = $aWinPos[0] + $aContrPos[0] - 205
	$iY = $aWinPos[1] + $aContrPos[1] - 100
	Opt('GUIOnEventMode', 0)
	$hFinishGui = GUICreate('', 537, 138, $iX, $iY, BitOR($WS_POPUP, $WS_BORDER), $WS_EX_TOPMOST, $hGui)
	$hF1 = GUICtrlCreateButton('', 5, 5, 128, 128, $BS_ICON)
	GUICtrlSetImage(-1, $sGfxPath & 'finish10.ico')
	GUICtrlSetTip(-1, 'Spielende nach 10 Liedern')
	$hF2 = GUICtrlCreateButton('', 138, 5, 128, 128, $BS_ICON)
	GUICtrlSetImage(-1, $sGfxPath & 'finish20.ico')
	GUICtrlSetTip(-1, 'Spielende nach 20 Liedern')
	$hF3 = GUICtrlCreateButton('', 271, 5, 128, 128, $BS_ICON)
	GUICtrlSetImage(-1, $sGfxPath & 'finish50.ico')
	GUICtrlSetTip(-1, 'Spielende nach 50 Liedern')
	$hF4 = GUICtrlCreateButton('', 404, 5, 128, 128, $BS_ICON)
	GUICtrlSetImage(-1, $sGfxPath & 'finish100.ico')
	GUICtrlSetTip(-1, 'Spielende nach 100 Liedern')
	GUISetState(@SW_SHOW, $hFinishGui)
	While True
		Switch GUIGetMsg()
			Case $hF1
				$iFinish = 10
				GUICtrlSetImage($hFinish, $sGfxPath & 'finish10.ico')
				ExitLoop
			Case $hF2
				$iFinish = 20
				GUICtrlSetImage($hFinish, $sGfxPath & 'finish20.ico')
				ExitLoop
			Case $hF3
				$iFinish = 50
				GUICtrlSetImage($hFinish, $sGfxPath & 'finish50.ico')
				ExitLoop
			Case $hF4
				$iFinish = 100
				GUICtrlSetImage($hFinish, $sGfxPath & 'finish100.ico')
				ExitLoop
		EndSwitch
	WEnd
	GUIDelete($hFinishGui)
	Opt('GUIOnEventMode', 1)
	_CheckStartButton()
EndFunc   ;==>_SelectFinish

Func _ChangeDisplay()
	$fDisplayRes = Not $fDisplayRes
	Switch $fDisplayRes
		Case True
			_ChangeScreenResEx(1, 1024, 768)
			If Not @error Then GUICtrlSetState($hMenuConfigDisplay, $GUI_CHECKED)
		Case False
			_ChangeScreenResEx(1, $iOrigWidth, $iOrigHeight)
			If Not @error Then GUICtrlSetState($hMenuConfigDisplay, $GUI_UNCHECKED)
	EndSwitch
	WinMove($hGui, '', @DesktopWidth / 2 - 503, 10)
	IniWrite($sIniFile, 'Config', '1024x768', $fDisplayRes)
EndFunc   ;==>_ChangeDisplay

Func _TestInput()
	Local $iInputIndex, $aAllJoy
	For $i = 0 To 3
		If GUICtrlRead($ahAvatar[$i][0]) = 1 Then
			$iInputIndex = _GUICtrlComboBox_GetCurSel($ahAvatar[$i][6])
			If $iInputIndex = 0 Then
				If WinActive($hGui) Then
					If _IsPressed('20', $vDLL) Then GUICtrlSetData($ahAvatar[$i][7], 'Weiter')
					If _IsPressed('31', $vDLL) Then GUICtrlSetData($ahAvatar[$i][7], '1')
					If _IsPressed('32', $vDLL) Then GUICtrlSetData($ahAvatar[$i][7], '2')
					If _IsPressed('33', $vDLL) Then GUICtrlSetData($ahAvatar[$i][7], '3')
					If _IsPressed('34', $vDLL) Then GUICtrlSetData($ahAvatar[$i][7], '4')
				EndIf
			Else
				$aAllJoy = _GetAllJoy($aNumberJoy)
				If BitAND($aAllJoy[$iInputIndex - 1], 16) Then GUICtrlSetData($ahAvatar[$i][7], 'Weiter')
				If BitAND($aAllJoy[$iInputIndex - 1], 1) Then GUICtrlSetData($ahAvatar[$i][7], '1')
				If BitAND($aAllJoy[$iInputIndex - 1], 2) Then GUICtrlSetData($ahAvatar[$i][7], '2')
				If BitAND($aAllJoy[$iInputIndex - 1], 4) Then GUICtrlSetData($ahAvatar[$i][7], '3')
				If BitAND($aAllJoy[$iInputIndex - 1], 8) Then GUICtrlSetData($ahAvatar[$i][7], '4')
			EndIf
		EndIf
	Next
EndFunc   ;==>_TestInput

Func _WM_VSCROLL($hWnd, $Msg, $wParam, $lParam)
	_SelectGender()
	Return $GUI_RUNDEFMSG
EndFunc   ;==>_WM_VSCROLL

Func _KeyboardInfo()
	Local $aPos = WinGetPos($hGui)
	SplashImageOn('Hilfe  -  Tastatur-Belegung', $sGfxPath & 'keyconfig.jpg', 234, 264, $aPos[0] + 380, $aPos[1] + 75)
	Do
		Sleep(20)
	Until _IsPressed('01', $vDLL)
	SplashOff()
EndFunc   ;==>_KeyboardInfo

Func _SelectMP3Folder()
	Local $sPath
	Opt('GUIOnEventMode', 0)
	GUISetState(@SW_SHOW, $hSelectFolder)
	While True
		Switch GUIGetMsg()
			Case $GUI_EVENT_CLOSE
				_GUICtrlStatusBar_SetText($hStatus, ' Bereit.')
				ExitLoop
			Case $hClear
				Global $aMP3Pool[1] = [0]
				_GUICtrlStatusBar_SetIcon($hMainStatus, 1, $hNoIcon)
				_GUICtrlStatusBar_SetText($hMainStatus, ' Keine MP3-Dateien ausgewhlt!', 1)
				_GUICtrlListView_DeleteAllItems($hWndLW)
			Case $hAdd
				$sMP3WorkDir = IniRead($sIniFile, 'Config', 'MP3WorkDir', @WorkingDir)
				$sPath = FileSelectFolder('MP3-Ordner auswhlen', '', 2, $sMP3WorkDir, $hSelectFolder)
				If FileExists($sPath) Then
					GUICtrlCreateListViewItem($sPath & '|...', $hListView)
					$sMP3WorkDir = $sPath
					IniWrite($sIniFile, 'Config', 'MP3WorkDir', $sPath)
					FileChangeDir($sPath)
				EndIf
			Case $hDel
				_GUICtrlListView_DeleteItemsSelected($hWndLW)
			Case $hOk
				Global $aMP3Pool[1] = [0]
				If _GUICtrlListView_GetItemCount($hWndLW) > 0 Then _ReadMP3Pool()
				If $aMP3Pool[0] >= 100 Then
					$fMP3Select = True
					_SaveDB($sDBFile, $hListView)
				Else
					_GUICtrlStatusBar_SetText($hStatus, ' Achtung! Fr das Spiel werden min. 100 MP3-Dateien bentigt.')
					ContinueLoop
				EndIf
				ExitLoop
		EndSwitch
	WEnd
	_CheckStartButton()
	GUISetState(@SW_HIDE, $hSelectFolder)
	Opt('GUIOnEventMode', 1)
EndFunc   ;==>_SelectMP3Folder

Func _ShowChoice($sSwitch)
	For $i = 0 To 3
		GUICtrlSetState($ahChoice[$i][0], $sSwitch)
		GUICtrlSetState($ahChoice[$i][1], $sSwitch)
	Next
EndFunc   ;==>_ShowChoice

Func _LoadDB($sDBFile, $hListView) ; Datenbank-Datei laden
	Local $sItem, $hLVHandle = GUICtrlGetHandle($hListView)
	Local $hFile = FileOpen($sDBFile, 0) ; Datei zum lesen ffnen
	If $hFile <> -1 Then ; wenn das ffnen erfolgreich war, dann...
		_GUICtrlListView_BeginUpdate($hLVHandle) ; Listview sperren
		While True ; Endlosschleife
			$sItem = FileReadLine($hFile) ; Zeile aus der Datei lesen
			If @error Then ExitLoop ; wenn das Ende der Datei erreicht ist, dann Endlosschleife verlassen
			GUICtrlCreateListViewItem($sItem, $hListView) ; mit den eingelesenen Daten einen neuen Listview-Eintrag erstellen
		WEnd
		_GUICtrlListView_EndUpdate($hLVHandle) ; Listview wieder freigeben
		FileClose($hFile) ; Datei schlieen
	EndIf
EndFunc   ;==>_LoadDB

Func _SaveDB($sDBFile, $hListView) ; Datenbank-Datei speichern
	Local $sItem, $hLVHandle = GUICtrlGetHandle($hListView)
	Local $iCount = _GUICtrlListView_GetItemCount($hLVHandle) - 1 ; Anzahl der Listview-Eintrge holen
	Local $hFile = FileOpen($sDBFile, 2) ; Datei zum speichern (berschreiben) ffnen
	If $hFile <> -1 Then ; wenn das ffnen erfolgreich war, dann...
		For $i = 0 To $iCount ; Schleife, um alle Listview-Eintrge durchzugehen
			$sItem = _GUICtrlListView_GetItemTextString($hLVHandle, $i) ; die Werte aus dem Listview-Eintrag holen
			FileWriteLine($hFile, $sItem) ; und in die Datei schreiben
		Next
		FileClose($hFile) ; Datei schlieen
	EndIf
EndFunc   ;==>_SaveDB

Func _ReadMP3Pool()
	If _GUICtrlListView_GetItemCount($hWndLW) = 0 Then Return
	Local $aMP3, $sPath, $iCount
	_GUICtrlStatusBar_SetText($hStatus, ' Lese Verzeichnisse... Bitte warten!')
	_GUICtrlStatusBar_SetText($hMainStatus, ' Lese Verzeichnisse... Bitte warten!')
	For $i = 0 To _GUICtrlListView_GetItemCount($hWndLW) - 1
		$sPath = _GUICtrlListView_GetItemText($hWndLW, $i)
		$aMP3 = _RecursiveFileListToArray($sPath, '.+\.mp3', 1)
		If $aMP3[0] > 0 Then
			_GUICtrlListView_SetItemText($hWndLW, $i, $aMP3[0], 1)
			$iCount = UBound($aMP3Pool)
			ReDim $aMP3Pool[$iCount + $aMP3[0]]
			For $j = 1 To $aMP3[0]
				$aMP3Pool[$iCount + $j - 1] = $aMP3[$j]
			Next
		EndIf
	Next
	$fMP3Select = True
	$aMP3Pool[0] = UBound($aMP3Pool) - 1
	$aMP3PoolBack = $aMP3Pool
	_GUICtrlStatusBar_SetText($hStatus, ' Fertig.')
	_GUICtrlStatusBar_SetText($hMainStatus, ' Einstellungen fr das Spiel vornehmen.')
	_GUICtrlStatusBar_SetIcon($hMainStatus, 1, $hAudioIcon)
	_GUICtrlStatusBar_SetText($hMainStatus, $aMP3Pool[0] & ' MP3-Dateien ausgewhlt.', 1)
EndFunc   ;==>_ReadMP3Pool

Func _RecursiveFileListToArray($sPath, $sPattern = '', $iFlag = 0, $iFormat = 1, $iRecursion = 1, $sDelim = @CRLF)
	Local $hSearch, $sFile, $sReturn = ''
	If StringRight($sPath, 1) <> '\' Then $sPath &= '\'
	$hSearch = FileFindFirstFile($sPath & '*.*')
	If @error Or $hSearch = -1 Then Return SetError(1, 0, $sReturn)
	While True
		$sFile = FileFindNextFile($hSearch)
		If @error Then ExitLoop
		If @extended Then
			If StringRegExp($sPath & $sFile, $sPattern) And ($iFlag = 0 Or $iFlag = 2) Then $sReturn &= $sPath & $sFile & '\' & $sDelim
			If $iRecursion Then $sReturn &= _RecursiveFileListToArray($sPath & $sFile & '\', $sPattern, $iFlag, 0)
			ContinueLoop
		EndIf
		If StringRegExp($sFile, $sPattern) And ($iFlag = 0 Or $iFlag = 1) Then $sReturn &= $sPath & $sFile & $sDelim
	WEnd
	FileClose($hSearch)
	If $iFormat And $sReturn = '' Then Return StringSplit($sReturn, '', $iFormat)
	If $iFormat Then Return StringSplit(StringTrimRight($sReturn, StringLen($sDelim)), $sDelim, $iFormat)
	Return $sReturn
EndFunc   ;==>_RecursiveFileListToArray

Func _SelectGender()
	Local $nID = _WinAPI_GetDlgCtrlID(ControlGetHandle($hGui, '', ControlGetFocus($hGui))) - $ahAvatar[0][0]
	Local $iUser = Int($nID / 8), $aGender[2] = ['f', 'm']
	Local $iSelect = BitAND(GUICtrlRead($ahAvatar[$iUser][4]), $GUI_CHECKED)
	Local $iAvatar = GUICtrlRead($ahAvatar[$iUser][2])
	ControlFocus($hGui, '', $ahAvatar[$iUser][2])
	GUICtrlSetImage($ahAvatar[$iUser][0], $sAvatarPath & $aGender[$iSelect] & $iAvatar & '.ico')
EndFunc   ;==>_SelectGender

Func _AvatarGetCount()
	Local $iCount = 0
	For $i = 0 To 3
		If GUICtrlRead($ahAvatar[$i][0]) <> '0' Then $iCount += 1
	Next
	Return $iCount
EndFunc   ;==>_AvatarGetCount

Func _ActivateUser()
	Local $nID = @GUI_CtrlId - $ahAvatar[0][0]
	Local $iUser = Int($nID / 8)
	Local $iCount = _AvatarGetCount()
	Switch GUICtrlRead($ahAvatar[$iUser][0])
		Case '0'
			If UBound($aComboData) <= $iCount Then
				_PlayDefaultSystemSound('SystemHand')
				_GUICtrlStatusBar_SetText($hMainStatus, ' Fehler! Es stehen nicht gengend Eingabegerte zur Verfgung!')
				Return
			EndIf
			_SelectGender()
			GUICtrlSetData($ahAvatar[$iUser][0], '1')
			GUICtrlSetData($ahAvatar[$iUser][6], '')
			GUICtrlSetData($ahAvatar[$iUser][6], $sComboData, $aComboData[$iCount])
			For $i = 2 To 7
				GUICtrlSetState($ahAvatar[$iUser][$i], $GUI_SHOW)
			Next
			ControlFocus($hGui, '', $ahAvatar[$iUser][2])
		Case '1'
			_GUICtrlStatusBar_SetText($hMainStatus, ' Einstellungen fr das Spiel vornehmen.')
			GUICtrlSetImage($ahAvatar[$iUser][0], $sAvatarPath & 'fm.ico')
			GUICtrlSetData($ahAvatar[$iUser][0], '0')
			For $i = 2 To 7
				GUICtrlSetState($ahAvatar[$iUser][$i], $GUI_HIDE)
			Next
	EndSwitch
	_CheckStartButton()
EndFunc   ;==>_ActivateUser

Func _CheckStartButton()
	Local $iCheck
	For $i = 0 To 3
		$iCheck += GUICtrlRead($ahAvatar[$i][0])
	Next
	If $iCheck > 0 And $iFinish > 0 And $aMP3Pool[0] > $iFinish + 4 Then
		GUICtrlSetState($hStart, $GUI_ENABLE)
		GUICtrlSetImage($hStart, $sGfxPath & 'start1.ico')
	Else
		GUICtrlSetState($hStart, $GUI_DISABLE)
		GUICtrlSetImage($hStart, $sGfxPath & 'start0.ico')
	EndIf
EndFunc   ;==>_CheckStartButton

Func _StartGame()
	AdlibUnRegister('_TestInput')
	_GUICtrlStatusBar_SetText($hMainStatus, ' Spielbeginn.')
	GUICtrlSetState($hBkPic, $GUI_HIDE)
	GUICtrlSetState($hFolder, $GUI_HIDE)
	GUICtrlSetState($hFinish, $GUI_HIDE)
	GUICtrlSetState($hMenuConfigSelect, $GUI_DISABLE)
	GUICtrlSetState($hStart, $GUI_HIDE)
	GUICtrlSetState($hSpeaker1, $GUI_SHOW)
	GUICtrlSetState($hSpeaker2, $GUI_SHOW)
	GUICtrlSetState($hLevel1, $GUI_SHOW)
	GUICtrlSetState($hLevel2, $GUI_SHOW)
	GUICtrlSetState($hLine1, $GUI_SHOW)
	GUICtrlSetState($hLine2, $GUI_SHOW)
	GUICtrlSetState($hNote1, $GUI_SHOW)
	GUICtrlSetState($hNote2, $GUI_SHOW)
	GUICtrlSetState($hScore, $GUI_SHOW)
	GUICtrlSetState($hScoreLabel, $GUI_SHOW)
	GUICtrlSetState($hCount, $GUI_SHOW)
	GUICtrlSetState($hCountLabel, $GUI_SHOW)
	GUICtrlSetState($hTimeScore, $GUI_SHOW)
	For $i = 0 To 20
		If Mod($i, 5) = 0 Or $i = 0 Then GUICtrlSetState($ahProgrLabel[Int($i / 5)], $GUI_SHOW)
		GUICtrlSetState($ahProgrTics[$i], $GUI_SHOW)
	Next
	For $i = 0 To 3
		GUICtrlSetOnEvent($ahAvatar[$i][0], '')
		GUICtrlSetTip($ahAvatar[$i][0], '')
		GUICtrlSetState($ahAvatar[$i][1], $GUI_SHOW)
		GUICtrlSetState($ahAvatar[$i][2], $GUI_HIDE)
		GUICtrlSetState($ahAvatar[$i][6], $GUI_DISABLE)
		GUICtrlSetBkColor($ahAvatar[$i][7], 0xCCCCCC)
		GUICtrlSetColor($ahAvatar[$i][7], 0xCCCCCC)
		GUICtrlSetData($ahAvatar[$i][7], '0')
		GUICtrlSetTip($ahAvatar[$i][7], '')
		GUICtrlSetState($ahAvatar[$i][3], $GUI_DISABLE)
		GUICtrlSetState($ahAvatar[$i][4], $GUI_DISABLE)
		GUICtrlSetState($ahAvatar[$i][5], $GUI_DISABLE)
		GUICtrlSetState($ahChoice[$i][0], $GUI_SHOW)
		GUICtrlSetState($ahChoice[$i][1], $GUI_SHOW)
		$aUserHiScore[$i][1] = GUICtrlRead($ahAvatar[$i][5])
		$aUserHiScore[$i][2] = 0
		$aUserHiScore[$i][3] = 0
		$aUserHiScore[$i][4] = 0
		$aUserHiScore[$i][5] = 0
		$aUserHiScore[$i][6] = 0
	Next
	_NewRound()
EndFunc   ;==>_StartGame

Func _MenuNewGame()
	If MsgBox(4 + 32 + 256 + 262144, 'Neues Spiel?', 'Wirklich ein neues Spiel beginnen?', 0, $hGui) = 7 Then Return
	$fNewGame = True
EndFunc   ;==>_MenuNewGame

Func _NewGame()
	_GUICtrlStatusBar_SetText($hMainStatus, ' Einstellungen fr das Spiel vornehmen.')
	GUICtrlSetState($hSpeaker1, $GUI_HIDE)
	GUICtrlSetState($hSpeaker2, $GUI_HIDE)
	GUICtrlSetState($hLevel1, $GUI_HIDE)
	GUICtrlSetState($hLevel2, $GUI_HIDE)
	GUICtrlSetState($hLine1, $GUI_HIDE)
	GUICtrlSetState($hLine2, $GUI_HIDE)
	GUICtrlSetState($hNote1, $GUI_HIDE)
	GUICtrlSetState($hNote2, $GUI_HIDE)
	GUICtrlSetState($hScore, $GUI_HIDE)
	GUICtrlSetData($hScore, 0)
	GUICtrlSetState($hScoreLabel, $GUI_HIDE)
	GUICtrlSetState($hCount, $GUI_HIDE)
	GUICtrlSetData($hCount, 0)
	GUICtrlSetState($hCountLabel, $GUI_HIDE)
	GUICtrlSetState($hTimeScore, $GUI_HIDE)
	GUICtrlSetData($hTimeScore, 0)
	GUICtrlSetState($hBkPic, $GUI_SHOW)
	GUICtrlSetState($hFolder, $GUI_SHOW)
	GUICtrlSetState($hFinish, $GUI_SHOW)
	GUICtrlSetState($hMenuConfigSelect, $GUI_ENABLE)
	GUICtrlSetState($hStart, $GUI_SHOW)
	For $i = 0 To 20
		If Mod($i, 5) = 0 Or $i = 0 Then GUICtrlSetState($ahProgrLabel[Int($i / 5)], $GUI_HIDE)
		GUICtrlSetState($ahProgrTics[$i], $GUI_HIDE)
	Next
	For $i = 0 To 3
		GUICtrlSetOnEvent($ahAvatar[$i][0], '_ActivateUser')
		GUICtrlSetTip($ahAvatar[$i][0], 'Mitspieler de-/aktivieren')
		GUICtrlSetState($ahAvatar[$i][1], $GUI_HIDE)
		GUICtrlSetData($ahAvatar[$i][1], 0)
		If GUICtrlRead($ahAvatar[$i][0]) = 1 Then GUICtrlSetState($ahAvatar[$i][2], $GUI_SHOW)
		GUICtrlSetState($ahAvatar[$i][6], $GUI_ENABLE)
		GUICtrlSetBkColor($ahAvatar[$i][7], 0x55FF55)
		GUICtrlSetColor($ahAvatar[$i][7], 0x000000)
		GUICtrlSetData($ahAvatar[$i][7], 'Eingabe-Test')
		GUICtrlSetTip($ahAvatar[$i][7], 'Eingabegert testen (Tastatur-Belegung siehe Hilfe)')
		GUICtrlSetState($ahAvatar[$i][3], $GUI_ENABLE)
		GUICtrlSetState($ahAvatar[$i][4], $GUI_ENABLE)
		GUICtrlSetState($ahAvatar[$i][5], $GUI_ENABLE)
		GUICtrlSetData($ahChoice[$i][1], '')
		GUICtrlSetBkColor($ahChoice[$i][0], 0x3333AA)
		GUICtrlSetBkColor($ahChoice[$i][1], 0xDDDDFF)
	Next
	AdlibRegister('_TestInput', 25)
EndFunc   ;==>_NewGame

Func _WaitStartkey()
	Local $aAllJoy
	Do
		Sleep(20)
		If WinActive($hGui) Then
			If _IsPressed('20', $vDLL) Then ExitLoop
			If _IsPressed('0D', $vDLL) Then _ShowHiScore()
		EndIf
		If $aNumberJoy[0] > 0 Then
			$aAllJoy = _GetAllJoy($aNumberJoy)
			For $i = 1 To $aNumberJoy[0]
				If BitAND($aAllJoy[$aNumberJoy[$i]], 64) Then _ShowHiScore()
				If BitAND($aAllJoy[$aNumberJoy[$i]], 16) Then ExitLoop 2
			Next
		EndIf
	Until $fNewGame
EndFunc   ;==>_WaitStartkey

Func _ShowHiScore()
	Local $aAllJoy
	_RefreshHiScoreTable()
	_ShowChoice($GUI_HIDE)
	GUICtrlSetState($hHiScoreTable, $GUI_SHOW)
	Sleep(200)
	Do
		Sleep(20)
		If _IsPressed('0D', $vDLL) And WinActive($hGui) Then ExitLoop
		If $aNumberJoy[0] > 0 Then
			$aAllJoy = _GetAllJoy($aNumberJoy)
			For $i = 1 To $aNumberJoy[0]
				If BitAND($aAllJoy[$aNumberJoy[$i]], 64) Then ExitLoop 2
			Next
		EndIf
	Until $fNewGame
	GUICtrlSetState($hHiScoreTable, $GUI_HIDE)
	_ShowChoice($GUI_SHOW)
	Sleep(200)
EndFunc   ;==>_ShowHiScore

Func _RefreshHiScoreTable($fApply = False)
	Local $aHiScoreTmp = $aHiScoreList, $hWndHiScore = GUICtrlGetHandle($hHiScoreTable), $sTmp
	ReDim $aHiScoreTmp[104][7]
	For $i = 0 To 3
		If GUICtrlRead($ahAvatar[$i][0]) = 1 Then
			For $j = 0 To 6
				$aHiScoreTmp[100 + $i][$j] = $aUserHiScore[$i][$j]
			Next
		EndIf
	Next
	_SortHiScoreList($aHiScoreTmp)
	ReDim $aHiScoreTmp[100][7]
	_GUICtrlListView_BeginUpdate($hWndHiScore)
	_GUICtrlListView_DeleteAllItems($hWndHiScore)
	For $i = 0 To 99
		$aHiScoreTmp[$i][0] = $i + 1
		$sTmp = $i + 1
		For $j = 1 To 6
			$sTmp &= '|' & $aHiScoreTmp[$i][$j]
		Next
		GUICtrlCreateListViewItem($sTmp, $hHiScoreTable)
	Next
	_GUICtrlListView_EndUpdate($hWndHiScore)
	If $fApply Then $aHiScoreList = $aHiScoreTmp
EndFunc   ;==>_RefreshHiScoreTable

Func _SortHiScoreList(ByRef $aHiScore)
	Local $sTmp
	For $i = 0 To UBound($aHiScore) - 2
		For $j = $i + 1 To UBound($aHiScore) - 1
			If Number($aHiScore[$i][5]) < Number($aHiScore[$j][5]) Then
				For $x = 0 To 6
					$sTmp = $aHiScore[$i][$x]
					$aHiScore[$i][$x] = $aHiScore[$j][$x]
					$aHiScore[$j][$x] = $sTmp
				Next
			EndIf
		Next
	Next
EndFunc   ;==>_SortHiScoreList

Func _SaveHiScoreList()
	Local $sData = '', $sTmp, $hFile
	For $i = 0 To 99
		$sTmp = ''
		For $j = 0 To 6
			$sTmp &= $aHiScoreList[$i][$j] & '|'
		Next
		$sData &= StringTrimRight($sTmp, 1) & '<'
	Next
	$sData = StringTrimRight($sData, 1)
	$sData &= '#' & _Crypt_HashData($sData, $CALG_MD5)
	$sData = _StringEncryptXOR($sData, $sPassword)
	$hFile = FileOpen($sHiScoreFile, 10)
	If $hFile <> -1 Then
		FileWrite($hFile, $sData)
		FileClose($hFile)
	EndIf
EndFunc   ;==>_SaveHiScoreList

Func _LoadHiScoreList()
	Local $sData, $aData, $hFile, $aRow, $aCol
	$hFile = FileOpen($sHiScoreFile, 0)
	If $hFile = -1 Then Return SetError(1)
	$sData = FileRead($hFile)
	FileClose($hFile)
	$sData = _StringEncryptXOR($sData, $sPassword)
	$aData = StringSplit($sData, '#', 2)
	If Not IsArray($aData) Or UBound($aData) <> 2 Then Return SetError(2)
	If _Crypt_HashData($aData[0], $CALG_MD5) <> $aData[1] Then Return SetError(3)
	$aRow = StringSplit($aData[0], '<', 2)
	If Not IsArray($aRow) Or UBound($aRow) <> 100 Then Return SetError(4)
	For $i = 0 To 99
		$aCol = StringSplit($aRow[$i], '|', 2)
		If Not IsArray($aCol) Or UBound($aCol) <> 7 Then Return SetError(5)
		For $j = 0 To 6
			$aHiScoreList[$i][$j] = $aCol[$j]
		Next
	Next
EndFunc   ;==>_LoadHiScoreList

Func _StringEncryptXOR($sText, $sPass)
	If $sPass = '' Or $sText = '' Then Return SetError(1, 0, 0)
	Local $iTextChar, $iPos, $iPassChar, $iLen = StringLen($sPass)
	For $i = 1 To StringLen($sText)
		$iTextChar = Asc(StringMid($sText, $i, 1))
		$iPos = Mod($i - 1, $iLen) + 1
		$iPassChar = Asc(StringMid($sPass, $iPos, 1))
		$sText = StringReplace($sText, $i, Chr(BitXOR($iTextChar, $iPassChar)), 1)
	Next
	Return $sText
EndFunc   ;==>_StringEncryptXOR

Func _NewRound()
	_WaitStartkey()
	Local $aChoice[4], $aID3Tags, $iRnd, $sDoubleCheck, $iTimer, $sMsg, $iLength
	If $iCorrect <> -1 Then
		GUICtrlSetBkColor($ahChoice[$iCorrect][0], 0x3333AA)
		GUICtrlSetBkColor($ahChoice[$iCorrect][1], 0xDDDDFF)
		For $i = 0 To 3
			GUICtrlSetColor($ahAvatar[$i][7], 0xCCCCCC)
			GUICtrlSetBkColor($ahAvatar[$i][7], 0xCCCCCC)
			GUICtrlSetData($ahAvatar[$i][7], '0')
		Next
	EndIf
	For $i = 0 To 3
		GUICtrlSetData($ahChoice[$i][1], '- - -' & @CRLF & '- - -')
	Next
	GUISetState(@SW_LOCK, $hGui)
	$iTimer = TimerInit()
	Do
		If TimerDiff($iTimer) > 8000 Then
			$sMsg = 'FEHLER!   Zeitberschreitung bei MP3-Auswahl.\n\n'
			$sMsg &= 'Mgliche Ursachen:\n   - ID3-Tags nicht korrekt gesetzt\n'
			$sMsg &= 'Weitere Informationen stehen in der Datei "WrongMP3Files.txt" in:\n"%s"\n\nProgramm wird jetzt beendet!\n'
			MsgBox(16 + 262144, $sTitle, StringFormat($sMsg, $sAppPath), 0, $hGui)
			_End()
		EndIf
		$sDoubleCheck = ''
		If $hSoundOpen Then
			_BASS_ChannelStop($hSoundOpen)
			$hSoundOpen = 0
		EndIf
		$iCorrect = Random(0, 3, 1)
		For $i = 0 To 3
			Do
				$iRnd = Random(1, $aMP3Pool[0], 1)
				$aChoice[$i] = $aMP3Pool[$iRnd]
				$aID3Tags = _ReadID3Tag($aMP3Pool[$iRnd])
				If @error Then
					$aMP3Pool[$iRnd] = $aMP3Pool[$aMP3Pool[0]]
					$aMP3Pool[0] -= 1
					If $aMP3Pool[0] = 4 Then $aMP3Pool = $aMP3PoolBack
					_WriteLogfile('_ReadID3Tag Fehler-Nr.: ' & @error & ' -> ' & $aChoice[$i])
					ContinueLoop
				EndIf
				If ($aID3Tags[0][1] = '') Or ($aID3Tags[1][1] = '') Then
					$aMP3Pool[$iRnd] = $aMP3Pool[$aMP3Pool[0]]
					$aMP3Pool[0] -= 1
					If $aMP3Pool[0] = 4 Then $aMP3Pool = $aMP3PoolBack
					_WriteLogfile('fehlende ID3-Tags: ' & $aChoice[$i])
					ContinueLoop
				EndIf
				If StringInStr($sDoubleCheck, StringRegExpReplace($aID3Tags[0][1] & $aID3Tags[1][1], '\s', '')) Then SetError(1)
			Until Not @error
			If $i = $iCorrect Then
				$aMP3Pool[$iRnd] = $aMP3Pool[$aMP3Pool[0]]
				$aMP3Pool[0] -= 1
				If $aMP3Pool[0] = 4 Then $aMP3Pool = $aMP3PoolBack
			EndIf
			$sDoubleCheck &= StringLower(StringRegExpReplace($aID3Tags[0][1] & $aID3Tags[1][1], '\s', '')) & '|'
			$aID3Tags[0][1] = StringReplace($aID3Tags[0][1], '&', '&&')
			$aID3Tags[1][1] = StringReplace($aID3Tags[1][1], '&', '&&')
			GUICtrlSetData($ahChoice[$i][1], $aID3Tags[1][1] & @CRLF & '"' & $aID3Tags[0][1] & '"')
		Next
		$hSoundOpen = _BASS_StreamCreateFile(False, $aChoice[$iCorrect], 0, 0, BitOR($BASS_MUSIC_PRESCAN, $BASS_STREAM_AUTOFREE))
		If @error Then _WriteLogfile('Fehler beim ffnen der Datei: ' & $aChoice[$iCorrect])
	Until Not @error
	GUISetState(@SW_UNLOCK, $hGui)
	$iLength = _BASS_ChannelGetLength($hSoundOpen, $BASS_POS_BYTE)
	$iRnd = $iLength / 100 * Random(25, 75, 1)
	_BASS_ChannelSetPosition($hSoundOpen, $iRnd, $BASS_POS_BYTE + $BASS_MUSIC_POSRESET)
	_BASS_ChannelPlay($hSoundOpen, 0)
	GUICtrlSetData($hCount, GUICtrlRead($hCount) + 1)
	$iTimeScore = 100
	GUICtrlSetData($hTimeScore, $iTimeScore)
	GUICtrlSetData($hScore, $iTimeScore)
	_GUICtrlStatusBar_SetText($hMainStatus, ' Die Zeit luft...')
	GUICtrlSetState($hDummy, $GUI_FOCUS)
	AdlibRegister('_RefreshScore', 200)
	AdlibRegister('_GetUserInput', 20)
EndFunc   ;==>_NewRound

Func _WriteLogfile($sWrongMP3)
	If Not FileExists($sAppPath & 'WrongMP3Files.txt') Then
		FileWriteLine($sAppPath & 'WrongMP3Files.txt', 'Die folgenen Dateien sind fr das Musik-Quiz nicht geeignet:')
	EndIf
	FileWriteLine($sAppPath & 'WrongMP3Files.txt', $sWrongMP3)
	Return SetError(1)
EndFunc   ;==>_WriteLogfile

Func _RefreshScore()
	Local $iCount = 0, $aTmp, $iTmpScore, $iWinScore
	For $i = 0 To 3
		If GUICtrlRead($ahAvatar[$i][7]) <> '0' Then $iCount += 1
	Next
	If $iTimeScore = 0 Or _AvatarGetCount() = $iCount Then
		AdlibUnRegister('_GetUserInput')
		AdlibUnRegister('_RefreshScore')
		_BASS_ChannelStop($hSoundOpen)
		$hSoundOpen = 0
		$iHigh = 0
		GUICtrlSetData($hLevel1, 0)
		GUICtrlSetData($hLevel2, 0)
		GUICtrlSetBkColor($ahChoice[$iCorrect][0], 0x116611)
		GUICtrlSetBkColor($ahChoice[$iCorrect][1], 0xAAFFAA)
		For $i = 0 To 3
			$aTmp = StringSplit(GUICtrlRead($ahAvatar[$i][7]), ',', 2)
			If $aTmp[0] <> '0' Then
				GUICtrlSetColor($ahAvatar[$i][7], 0xFFFF44)
				$iTmpScore = GUICtrlRead($ahAvatar[$i][1])
				If $aTmp[0] = $iCorrect + 1 Then
					GUICtrlSetBkColor($ahAvatar[$i][7], 0x116611)
					$iWinScore = '+' & $aTmp[1]
					$aUserHiScore[$i][3] += 1
					$aUserHiScore[$i][5] = $iTmpScore + $aTmp[1]
				Else
					GUICtrlSetBkColor($ahAvatar[$i][7], 0xDD1111)
					$iWinScore = -$aTmp[1]
					$aUserHiScore[$i][4] += 1
					$aUserHiScore[$i][5] = $iTmpScore - $aTmp[1]
					If $aUserHiScore[$i][5] < 0 Then $aUserHiScore[$i][5] = 0
				EndIf
				GUICtrlSetData($ahAvatar[$i][1], $aUserHiScore[$i][5])
				GUICtrlSetData($ahAvatar[$i][7], 'Taste ' & $aTmp[0] & '  (' & $iWinScore & ')')
			Else
				$aUserHiScore[$i][4] += 1
			EndIf
			$aUserHiScore[$i][2] += 1
			$aUserHiScore[$i][6] = Round($aUserHiScore[$i][5] / $aUserHiScore[$i][2], 3)
		Next
		If GUICtrlRead($hCount) = $iFinish Then
			_GUICtrlStatusBar_SetText($hMainStatus, ' Spielende erreicht!')
			Sleep(2000)
			_RefreshHiScoreTable(True)
			_SaveHiScoreList()
			_ShowChoice($GUI_HIDE)
			GUICtrlSetState($hHiScoreTable, $GUI_SHOW)
			_ShowGameOver()
			GUICtrlSetState($hHiScoreTable, $GUI_HIDE)
			_NewGame()
			Return
		Else
			_GUICtrlStatusBar_SetText($hMainStatus, ' Auswertung beendet! Bereit fr ein neues Lied?')
			_NewRound()
		EndIf
	EndIf
	$iTimeScore -= 1
	GUISetState(@SW_DISABLE, $hGui)
	GUICtrlSetData($hTimeScore, $iTimeScore)
	GUICtrlSetData($hScore, $iTimeScore)
	GUISetState(@SW_ENABLE, $hGui)
EndFunc   ;==>_RefreshScore

Func _ShowGameOver()
	Local $hGameOverGui, $aWinPos, $iX, $iY, $hNewGame, $hEndGame
	$aWinPos = WinGetPos($hGui)
	$iX = $aWinPos[0] + 240
	$iY = $aWinPos[1] + 130
	Opt('GUIOnEventMode', 0)
	$hGameOverGui = GUICreate($sTitle & '   -   Ende', 500, 200, $iX, $iY, BitOR($WS_POPUP, $WS_CAPTION), $WS_EX_TOPMOST, $hGui)
	GUISetBkColor(0xFFFFAA)
	GUICtrlCreateIcon($sGfxPath & 'finish' & $iFinish & '.ico', -1, 5, 5, 128, 128)
	GUICtrlCreateLabel('Ziel erreicht!', 180, 10, 300, 60)
	GUICtrlSetFont(-1, 36, 400, 0, 'Times New Roman')
	$hNewGame = GUICtrlCreateButton('Neues Spiel', 220, 160, 130, 32)
	GUICtrlSetFont(-1, 12, 400, 0, 'Arial')
	$hEndGame = GUICtrlCreateButton('Spiel beenden', 360, 160, 130, 32)
	GUICtrlSetFont(-1, 12, 400, 0, 'Arial')
	GUISetState(@SW_SHOW, $hGameOverGui)
	While True
		Switch GUIGetMsg()
			Case $hNewGame
				ExitLoop
			Case $hEndGame
				GUIDelete($hGameOverGui)
				Opt('GUIOnEventMode', 1)
				_End()
				ExitLoop
		EndSwitch
	WEnd
	GUIDelete($hGameOverGui)
	Opt('GUIOnEventMode', 1)
EndFunc   ;==>_ShowGameOver

Func _GetUserInput()
	Local $aAllJoy, $iInputIndex
	For $i = 0 To 3
		If GUICtrlRead($ahAvatar[$i][0]) <> '0' Then
			If GUICtrlRead($ahAvatar[$i][7]) = '0' Then
				$iInputIndex = _GUICtrlComboBox_GetCurSel($ahAvatar[$i][6])
				If $iInputIndex = 0 And WinActive($hGui) Then
					If _IsPressed('31', $vDLL) Then GUICtrlSetData($ahAvatar[$i][7], '1,' & $iTimeScore)
					If _IsPressed('32', $vDLL) Then GUICtrlSetData($ahAvatar[$i][7], '2,' & $iTimeScore)
					If _IsPressed('33', $vDLL) Then GUICtrlSetData($ahAvatar[$i][7], '3,' & $iTimeScore)
					If _IsPressed('34', $vDLL) Then GUICtrlSetData($ahAvatar[$i][7], '4,' & $iTimeScore)
				Else
					$aAllJoy = _GetAllJoy($aNumberJoy)
					If BitAND($aAllJoy[$iInputIndex - 1], 1) Then GUICtrlSetData($ahAvatar[$i][7], '1,' & $iTimeScore)
					If BitAND($aAllJoy[$iInputIndex - 1], 2) Then GUICtrlSetData($ahAvatar[$i][7], '2,' & $iTimeScore)
					If BitAND($aAllJoy[$iInputIndex - 1], 4) Then GUICtrlSetData($ahAvatar[$i][7], '3,' & $iTimeScore)
					If BitAND($aAllJoy[$iInputIndex - 1], 8) Then GUICtrlSetData($ahAvatar[$i][7], '4,' & $iTimeScore)
				EndIf
				If GUICtrlRead($ahAvatar[$i][7]) <> '0' Then
					GUICtrlSetColor($ahAvatar[$i][7], 0x4444FF)
					GUICtrlSetBkColor($ahAvatar[$i][7], 0x4444FF)
				EndIf
			EndIf
		EndIf
	Next
EndFunc   ;==>_GetUserInput

Func _ReadID3Tag($sPath)
	If Not FileExists($sPath) Then Return SetError(1, 0, 0)
	Local $hFile, $sData, $sID3Header, $iID3HeaderSize = 0, $iOffset, $iSize, $tmp
	Local $aID3v2Tags[8] = ['TIT2', 'TPE1', 'TALB', 'TYER', 'TLEN', 'TRCK', 'TCON', 'TENC']
	Local $aID3[11][2] = [ _
			['Title', ''],['Artist', ''],['Album', ''],['Year', ''], _
			['Length', '0'],['Track', ''],['Genre', ''],['Encoder', ''], _
			['MPEG-Version', ''],['Bitrate', ''],['Sample-Freq.', '']]
	Local $aMP3Version[4] = ['MPEG2.5', 'Reserved', 'MPEG2', 'MPEG1']
	Local $aMP3Layer[4] = ['Reserved', 'Layer III', 'Layer II', 'Layer I']
	Local $aMP3Bitrate[5][16] = [ _
			[000, 032, 064, 096, 128, 160, 192, 224, 256, 288, 320, 352, 384, 416, 448, 000], _
			[000, 032, 048, 056, 064, 080, 096, 112, 128, 160, 192, 224, 256, 320, 384, 000], _
			[000, 032, 040, 048, 056, 064, 080, 096, 112, 128, 160, 192, 224, 256, 320, 000], _
			[000, 032, 048, 056, 064, 080, 096, 112, 128, 144, 160, 176, 192, 224, 256, 000], _
			[000, 008, 016, 024, 032, 040, 048, 056, 064, 080, 096, 112, 128, 144, 160, 000]]
	Local $aSampleFreq[3][4] = [[44100, 48000, 32000, 0],[22050, 24000, 16000, 0],[11025, 12000, 8000, 0]]
	Local $sMP3FrameHeader, $iMP3Version, $sMP3Version, $sMP3Layer, $iMP3Bitrate, $iMP3SampleFreq
	Local $iVBRFrames = -1, $iVBRFilesize, $iVBRFlags
	$hFile = FileOpen($sPath, 16)
	If $hFile = -1 Then Return SetError(2, 0, 0)
	$sData = Binary(FileRead($hFile, 4))
	If BinaryMid($sData, 1, 3) = '0x494433' Then ; ID3 v2.x Kennung gefunden
		If BinaryMid($sData, 4, 1) = '0x03' Or BinaryMid($sData, 4, 1) = '0x04' Then ; nur v2.3 und 2.4
			FileRead($hFile, 2) ; 2 Bytes berspringen
			For $i = 0 To 3 ; berechne ID3-Headergre (4 Bytes, jedoch nur jeweils die unteren 7 Bit)
				$iID3HeaderSize = BitShift($iID3HeaderSize, -7) + ('0x' & Hex(FileRead($hFile, 1), 2))
			Next
			If $iID3HeaderSize > 0 Then
				$sID3Header = Binary(FileRead($hFile, $iID3HeaderSize)) ; lese gesamten ID3-Header
				For $i = 0 To 7
					$iOffset = StringInStr(BinaryToString($sID3Header), $aID3v2Tags[$i]) ; Offset zu dem ID3-Tag
					If $iOffset > 0 Then
						$iSize = Hex(BinaryMid($sID3Header, $iOffset + 4, 4)) ; Gre des ID3-Frames
						$tmp = BinaryMid($sID3Header, $iOffset + 11, Dec($iSize) - 1)
						For $x = 1 To BinaryLen($tmp)
							If BinaryMid($tmp, $x, 1) > 0x00 And BinaryMid($tmp, $x, 1) < 0xFE Then $aID3[$i][1] &= BinaryToString(BinaryMid($tmp, $x, 1))
						Next
;~ 						$aID3[$i][1] = BinaryToString($tmp) ; ID3-Tag auslesen
					EndIf
				Next
			EndIf
			$sData = Binary(FileRead($hFile, 4)) ; 1. MP3-Frameheader auslesen
		EndIf
	EndIf
	$sMP3FrameHeader = '0x' & Hex($sData)
	If Hex(BitAND($sMP3FrameHeader, 0xFFE00000), 8) <> 'FFE00000' Then Return SetError(3, 0, 0) ; keine MP3-Datei, dann Return
	$iMP3Version = BitShift(BitAND($sMP3FrameHeader, 0x180000), 19) ; welche MP3-Version
	$sMP3Version = $aMP3Version[$iMP3Version] ; in Textform
	$sMP3Layer = $aMP3Layer[BitShift(BitAND($sMP3FrameHeader, 0x60000), 17)] ; welcher Layer
	$aID3[8][1] = $sMP3Version & ' / ' & $sMP3Layer ; ins Ausgabe-Array
	$iMP3Bitrate = BitShift(BitAND($sMP3FrameHeader, 0xF000), 12) ; Bitraten-Index auslesen
	Switch $sMP3Version ; je nach MPEG-Version Bitrate aus der Tabelle holen
		Case 'MPEG1'
			$aID3[9][1] = $aMP3Bitrate[$iMP3Version - ($iMP3Version > 1)][$iMP3Bitrate]
		Case 'MPEG2', 'MPEG2.5'
			If $sMP3Layer = 'Layer I' Then
				$aID3[9][1] = $aMP3Bitrate[3][$iMP3Bitrate]
			Else
				$aID3[9][1] = $aMP3Bitrate[4][$iMP3Bitrate]
			EndIf
	EndSwitch
	$iMP3SampleFreq = BitShift(BitAND($sMP3FrameHeader, 0xC00), 10) ; Sample-Frequenz-Index auslesen
	$aID3[10][1] = $aSampleFreq[2 - ($iMP3Version - ($iMP3Version > 1))][$iMP3SampleFreq] ; und Wert aus der Tabelle holen
	Do ; evtl. Leerbytes berspringen
		$tmp = FileRead($hFile, 1)
		If @error Then ExitLoop
	Until $tmp <> 0x00 Or @error
	If $tmp = 0x58 And BinaryToString(FileRead($hFile, 3)) = 'ing' Then ; MP3 mit VBR (Xing-Header gefunden)?
		$iVBRFlags = '0x' & Hex(FileRead($hFile, 4)) ; VBR-Flags auslesen
		If BitAND($iVBRFlags, 0x3) Then ; wenn die Eintrge vorhanden sind, dann...
			$iVBRFrames = Dec(Hex(FileRead($hFile, 4))) ; Anzahl der VBR-Frames auslesen
			$iVBRFilesize = Dec(Hex(FileRead($hFile, 4))) ; Dateigre auslesen
			$aID3[4][1] = $iVBRFrames * 1152 / $aID3[10][1] * 1000 ; VBR Laufzeit
			$aID3[9][1] = 'VBR ~' & Int($iVBRFilesize * 8 / ($aID3[4][1] / 1000) / 1000) ; VBR durchschnittliche Bitrate
		EndIf
	Else
		If $aID3[4][1] = 0 Then $aID3[4][1] = (FileGetSize($sPath) * 8) / ($aID3[9][1] * 1000) * 1000 ; alternative CBR Laufzeit
		$aID3[9][1] = 'CBR ' & $aID3[9][1]
	EndIf
	$aID3[4][1] = _MyTicksToTime($aID3[4][1]) ; Laufzeit (Ticks to hour:min:sec)
	$aID3[9][1] &= ' kBit/s'
	$aID3[10][1] &= ' Hz'
	FileClose($hFile)
	Return $aID3
EndFunc   ;==>_ReadID3Tag

Func _MyTicksToTime($iTicks)
	Local $iHour, $iMins, $iSecs
	$iHour = Int($iTicks / 3600000)
	$iTicks -= $iHour * 3600000
	$iMins = Int($iTicks / 60000)
	$iTicks -= $iMins * 60000
	$iSecs = Int($iTicks / 1000)
	Return StringFormat('%02i:%02i:%02i', $iHour, $iMins, $iSecs)
EndFunc   ;==>_MyTicksToTime

Func _GetAllJoy(ByRef $aJoy)
	If $aJoy[0] = 0 Then Return $aJoy
	Local $aAllJoy[$aJoy[0]], $aTmp
	For $i = 1 To $aJoy[0]
		$lpJoy = _JoyInit()
		$aTmp = _GetJoy($lpJoy, $aJoy[$i])
		$aAllJoy[$i - 1] = $aTmp[7]
	Next
	Return $aAllJoy
EndFunc   ;==>_GetAllJoy

Func _NumberJoy()
	Local $aTmp, $j = 0, $aJoy[1] = [0], $lpJoy
	For $i = 0 To 15
		$lpJoy = _JoyInit()
		$aTmp = _GetJoy($lpJoy, $i)
		If $aTmp[0] <> 0 Then
			$j += 1
			ReDim $aJoy[$j + 1]
			$aJoy[$j] = $i
			$aJoy[0] = $j
		EndIf
	Next
	Return $aJoy
EndFunc   ;==>_NumberJoy

Func _ProgInfo()
	Local $sMsg = 'Version:\t%s\nDatum:\t%s\nAutor:\tOscar (www.autoit.de)\nEMail:\tOscar@elektronik-kurs.de\n\n'
	$sMsg &= 'Rechtliches:\n'
	$sMsg &= '- Dieses Programm darf, zeitlich unbegrenzt, kostenlos genutzt werden!\n'
	$sMsg &= '- Eine evtl. Weitergabe muss kostenlos, vollstndig und unverndert erfolgen!\n'
	$sMsg &= '- nderungen am Programm drfen nur durch den Autor vorgenommen werden!\n'
	MsgBox(0, $sTitle & '   -   Programm-Informationen', StringFormat($sMsg, $sVersion, $sVerDate), 0, $hGui)
EndFunc   ;==>_ProgInfo

Func _Thanks()
	Local $sMsg = 'An dieser Stelle mchte ich mich bei den Autoren folgender Funktionen bedanken:\n\n'
	$sMsg &= '- "http://un4seen.com"\n   fr die BASS Audio Library\n\n'
	$sMsg &= '- Brett "BrettF" Francis (brett[at]signa5[dot]com)\n   fr: bass.au3\n\n'
	$sMsg &= '- "Ejoc" und "Adam1213" (www.autoitscript.com)\n   fr: _JoyInit() und _GetJoy()\n\n'
	$sMsg &= '- "PartyPooper" und "bobchernow" (www.autoitscript.com)\n   fr: _ChangeScreenResEx()\n\n'
	$sMsg &= '- "funkey" (www.autoit.de)\n   fr: _PlayDefaultSystemSound()\n\n'
	$sMsg &= 'Bedanken mchte ich mich auch bei "www.iconshock.com" fr die Icons\n\n'
	$sMsg &= 'und bei "www.dressup247.com" fr den "Anime Avatar Creator"\n\n'
	$sMsg &= 'Auerdem bedanke ich mich bei "www.pixelio.de" und\nspeziell bei "Stephanie Hofschlaeger" fr das schne Vorhangbild\n\n'
	$sMsg &= 'Und zum Schlu bedanke ich mich schonmal im voraus bei allen,\ndie mir Fehlermeldungen, Kritik und Verbesserungsvorschlge zuschicken.\n\n'
	$sMsg &= 'Vielen Dank euch allen!\n'
	MsgBox(0, $sTitle & '   -   Danksagungen', StringFormat($sMsg, $sVersion), 0, $hGui)
EndFunc   ;==>_Thanks

;____________________________________________________________________
;      Original program by Ejoc                           ;
;      Improved by Adam1213 (autoit 3.2 compatiblity + improved labels            ;
;____________________________________________________________________
;======================================
;   _JoyInit()
;======================================
Func _JoyInit()
	Local $joy = DllStructCreate($JOYINFOEX_struct)
	DllStructSetData($joy, 1, DllStructGetSize($joy), 1);dwSize = sizeof(struct)
	DllStructSetData($joy, 1, 255, 2) ;dwFlags = GetAll
	Return $joy
EndFunc   ;==>_JoyInit

;======================================
;   _GetJoy($lpJoy,$iJoy)
;   $lpJoy Return from _JoyInit()
;   $iJoy  Joystick # 0-15
;   Return Array containing X-Pos, Y-Pos, Z-Pos, R-Pos, U-Pos, V-Pos,POV
;         Buttons down
;
;         *POV This is a digital game pad, not analog joystick
;         65535  = Not pressed
;         0    = U
;         4500   = UR
;         9000   = R
;         Goes around clockwise increasing 4500 for each position
;======================================
Func _GetJoy($lpJoy, $iJoy)
	Local $coor[8], $ret
	DllCall("Winmm.dll", "int", "joyGetPosEx", "int", $iJoy, "ptr", DllStructGetPtr($lpJoy))
	If Not @error Then
		$coor[0] = DllStructGetData($lpJoy, 1, 3)
		$coor[1] = DllStructGetData($lpJoy, 1, 4)
		$coor[2] = DllStructGetData($lpJoy, 1, 5)
		$coor[3] = DllStructGetData($lpJoy, 1, 6)
		$coor[4] = DllStructGetData($lpJoy, 1, 7)
		$coor[5] = DllStructGetData($lpJoy, 1, 8)
		$coor[6] = DllStructGetData($lpJoy, 1, 11)
		$coor[7] = DllStructGetData($lpJoy, 1, 9)
	EndIf
	Return $coor
EndFunc   ;==>_GetJoy

;===============================================================================
; Function Name:    _ChangeScreenResEx()
; Description:    Changes the current screen geometry, colour and refresh rate.
; Version:        1.0.0.0
; Parameter(s):  $i_DisplayNum - Display to change, starting at 1
;                  $i_Width - Width of the desktop screen in pixels. (horizontal resolution)
;                  $i_Height - Height of the desktop screen in pixels. (vertical resolution)
;                   $i_BitsPP - Depth of the desktop screen in bits per pixel.
;                   $i_RefreshRate - Refresh rate of the desktop screen in hertz.
; Requirement(s):   AutoIt Beta > 3.1
; Return Value(s):  On Success - Screen is adjusted, @ERROR = 0
;                  On Failure - sets @ERROR = 1
; Forum(s):
; Author(s):        Original code - psandu.ro, PartyPooper
;                  Modifications - bobchernow
;===============================================================================
Func _ChangeScreenResEx($i_DisplayNum = 1, $i_Width = @DesktopWidth, $i_Height = @DesktopHeight, $i_BitsPP = @DesktopDepth, $i_RefreshRate = @DesktopRefresh)
	Local Const $DM_PELSWIDTH = 0x00080000
	Local Const $DM_PELSHEIGHT = 0x00100000
	Local Const $DM_BITSPERPEL = 0x00040000
	Local Const $DM_DISPLAYFREQUENCY = 0x00400000
	Local Const $CDS_TEST = 0x00000002
	Local Const $CDS_UPDATEREGISTRY = 0x00000001
	Local Const $DISP_CHANGE_RESTART = 1
	Local Const $DISP_CHANGE_SUCCESSFUL = 0
	Local Const $HWND_BROADCAST = 0xffff
	Local Const $WM_DISPLAYCHANGE = 0x007E
	If $i_Width = "" Or $i_Width = -1 Then $i_Width = @DesktopWidth; default to current setting
	If $i_Height = "" Or $i_Height = -1 Then $i_Height = @DesktopHeight; default to current setting
	If $i_BitsPP = "" Or $i_BitsPP = -1 Then $i_BitsPP = @DesktopDepth; default to current setting
	If $i_RefreshRate = "" Or $i_RefreshRate = -1 Then $i_RefreshRate = @DesktopRefresh; default to current setting
	Local $DEVMODE = DllStructCreate("byte[32];int[10];byte[32];int[6]")
	Local $s_Display
	$s_Display = "\\.\Display" & $i_DisplayNum
	Local $B = DllCall("user32.dll", "int", "EnumDisplaySettings", "ptr", 0, "int", 0, "ptr", DllStructGetPtr($DEVMODE))
	If @error Then
		$B = 0
		SetError(1)
		Return $B
	Else
		$B = $B[0]
	EndIf
	If $B <> 0 Then
		DllStructSetData($DEVMODE, 2, BitOR($DM_PELSWIDTH, $DM_PELSHEIGHT, $DM_BITSPERPEL, $DM_DISPLAYFREQUENCY), 5)
		DllStructSetData($DEVMODE, 4, $i_Width, 2)
		DllStructSetData($DEVMODE, 4, $i_Height, 3)
		DllStructSetData($DEVMODE, 4, $i_BitsPP, 1)
		DllStructSetData($DEVMODE, 4, $i_RefreshRate, 5)
		$B = DllCall("user32.dll", "int", "ChangeDisplaySettingsEx", "str", $s_Display, "ptr", DllStructGetPtr($DEVMODE), "hwnd", 0, "dword", $CDS_TEST, "lparam", 0)
		If @error Then
			$B = -1
		Else
			$B = $B[0]
		EndIf
		Select
			Case $B = $DISP_CHANGE_RESTART
				$DEVMODE = ""
				Return 2
			Case $B = $DISP_CHANGE_SUCCESSFUL
				DllCall("user32.dll", "int", "ChangeDisplaySettingsEx", "str", $s_Display, "ptr", DllStructGetPtr($DEVMODE), "hwnd", 0, "dword", $CDS_UPDATEREGISTRY, "lparam", 0)
				DllCall("user32.dll", "int", "SendMessage", "hwnd", $HWND_BROADCAST, "int", $WM_DISPLAYCHANGE, _
						"int", $i_BitsPP, "int", $i_Height * 2 ^ 16 + $i_Width)
				$DEVMODE = ""
				Return 1
			Case Else
				$DEVMODE = ""
				SetError(1)
				Return $B
		EndSelect
	EndIf
EndFunc   ;==>_ChangeScreenResEx

; #FUNCTION# ====================================================================================================================
; Name...........:    _PlayDefaultSystemSound()
; Description ...:    Spielt einen Systemklang, welcher in der Registry definiert ist.
; Syntax.........:    _PlayDefaultSystemSound($sSoundName, $iWait = 0)
; Parameters ....:    $sSoundName                - Name des SystemSound's
;                    | Default                   - Standardton Warnsignal / Default Beep
;                    | CriticalBatteryAlarm      - Alarm bei kritischem Batteriestand / when battery is critical
;                    | DeviceConnect            - Gerteanschlu / when a device is connect
;                    | DeviceDisconnect          - Gertetrennung / when a device is disconnect
;                    | DeviceFail                - Gerteanschlu fehlgeschlagen / when a deviceconnect is fail
;                    | LowBatteryAlarm           - Alarm bei niedrigem Batteriestand / when battery is low
;                    | MailBeep                  - Posteingangsbenachrichtigung / when email is received
;                    | SystemAsterisk            - Stern / Asterisk
;                    | SystemExclamation         - Hinweis / when windows shows a warning
;                    | SystemExit                - Windows beenden / when Windows shuts down
;                    | SystemHand                - Kritischer Abbruch / when a critical stop occurs
;                    | SystemNotification        - Sprechblase / when a critical stop occurs
;                    | SystemStart               - Windows starten / when Windows starts up
;                    | WindowsLogoff             - beim Windows abmelden / when logging off Windows
;                    | WindowsLogon              - beim Windows anmelden / when logging on Windows
;                    | EmptyRecycleBin           - Lschen des Papierkorbs / when recycle bin is emptied
;                    | Navigating                - Browser Klick / navigating in browser

;                     $iWait                     - Warten bis SoundPlay beendet? (0 = nein / 1 = ja)
; Return values .:    -----
; Author ........:    funkey (AutoIt.de)
; ===============================================================================================================================
Func _PlayDefaultSystemSound($sSoundName, $iWait = 0) ; funkey
	Local $sKey = 'HKEY_CURRENT_USER\AppEvents\Schemes\Apps\.Default'
	If $sSoundName = 'EmptyRecycleBin' Or $sSoundName = 'Navigating' Then $sKey = 'HKEY_CURRENT_USER\AppEvents\Schemes\Apps\Explorer'
	Local $sFile = StringReplace(RegRead($sKey & '\' & $sSoundName & '\.Default', ''), '%SystemRoot%', @WindowsDir)
	If $sFile = "" Then
		SoundPlay(StringReplace(RegRead($sKey & '\.Default\.Default', ''), '%SystemRoot%', @WindowsDir), $iWait)
	Else
		SoundPlay($sFile, $iWait)
	EndIf
EndFunc   ;==>_PlayDefaultSystemSound
